import org.junit.Assert;
import org.junit.Test;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import static org.junit.Assert.*;

public class ArrazTest {
    Arraz arraz = new Arraz();

    @Test
    public void test1SumOfIntArray() {
        //given
        int [] testNums = {1, 3, 5, 8};
        int expected = 17;
        //when
        int actual = arraz.sumOfIntArray(testNums);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2SumOfIntArray() {
        //given
        int [] testNumbers = {0};
        int expected = 0;
        //when
        int actual = arraz.sumOfIntArray(testNumbers);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1SumOfDoubleArray() {
        //given
        Double[] spiffyHandyDoubleArray = new Double[] {1.0, 0.5, 3.6, 38.4, 17.3, 62.0, 9.0, 3.375, 0.0, 3.14159};
        Double expected = 138.31659;
        //when
        Double actual = arraz.sumOfDoubleArray(spiffyHandyDoubleArray);
        //then
        Assert.assertEquals(expected, actual, .01);
    }

    @Test
    public void test2SumOfDoubleArray() {
        //given
        Double[] doublyArray = new Double[] {12.432, 34.03, 12.0, 10.0};
        Double expected = 68.462;
        //when
        Double actual = arraz.sumOfDoubleArray(doublyArray);
        //then
        Assert.assertEquals(expected, actual, .001);
    }

    @Test
    public void test1AverageOfIntArray() {
        //given
        int [] intArray = {1, 3, 5, 7};
        int expected = 4;
        //when
        int actual = arraz.averageOfIntArray(intArray);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2AverageOfIntArray() {
        //given
        int [] intArray = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 50};
        int expected = 9;
        //when
        int actual = arraz.averageOfIntArray(intArray);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1AverageofDoubleArray() {
        //given
        Double [] doubleArray = {1.0, .5, .3, 2.95};
        Double expected = 1.1875;
        //when
        Double actual = arraz.averageOfDoubleArray(doubleArray);
        //then
        Assert.assertEquals(expected, actual, .01);
    }

    @Test
    public void test2AverageofDoubleArray() {
        //given
        Double [] tinyArray = {.000003, .03};
        Double expected = .0150015;
        //when
        Double actual = arraz.averageOfDoubleArray(tinyArray);
        //then
        Assert.assertEquals(expected, actual, .001);
    }

    @Test
    public void test1ContainsValue() {
        //given
        int [] inty = {1, 2, 3, 6, 7, 8};
        int numberToCheck = 5;
        boolean expected = false;
        //when
        boolean actual = arraz.containsValue(inty, numberToCheck);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2ContainsValue() {
        //given
        int [] inty = {1, 2, 3, 6, 7, 8};
        int numberToCheck = 3;
        boolean expected = true;
        //when
        boolean actual = arraz.containsValue(inty, numberToCheck);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1reverseArray() {
        //given
        int [] ints = {1, 2, 3, 4, 5, 6};
        int [] expected = {6, 5, 4, 3, 2, 1};
        //when
        int [] actual = arraz.reverseArray(ints);
        //then
        Assert.assertArrayEquals(expected, actual);
    }

    @Test
    public void test2reverseArray() {
        //given
        int[] spiffyHandyIntArray = new int[] {4,5,102,6,-7,12,};
        int [] expected = {12, -7, 6, 102, 5, 4};
        //when
        int [] actual = arraz.reverseArray(spiffyHandyIntArray);
        //then
        Assert.assertArrayEquals(expected, actual);
    }

    @Test
    public void test1getOddEvensOfArray() {
        //given
        int [] spiffy = {1, 2, 3, 4};
        int expected = 2;
        //when
        OddEven oe = arraz.getOddEvensOfArray(spiffy);
        int actual = oe.getEvens();
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2getOddEvensOfArray() {
        //given
        int [] spiffy = {4, 5, 6, 5, 4, 5, 6 ,7};
        int expected = 4;
        //when
        OddEven oe = arraz.getOddEvensOfArray(spiffy);
        int actual = oe.getOdds();
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1FindIndexOf() {
        //given
        int [] spiffy = {4, 5, 6, 5, 5, 6 ,7};
        int expected = 0;
        //when
        int actual = arraz.findIndexOf(spiffy, 4);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2FindIndexOf() {
        //given
        int [] spiffy = {1, 2, 3, 4, 5, 6, 22};
        int expected = 6;
        //when
        int actual = arraz.findIndexOf(spiffy, 22);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1CopyArrayByIterator() {
        //given
        Integer [] oldArray = {1, 2, 3, 4};
        Integer [] expected = {1, 2, 3, 4};
        //when
        Integer[] actual = arraz.copyArrayByIterator(oldArray);
        //
        Assert.assertArrayEquals(expected, actual);
    }

    @Test
    public void test2CopyArrayByIterator() {
        //given
        Integer [] oldArray = {33, 4, 2, 4, 5, 12, 12, 12, 12, 12, 14};
        Integer [] expected = {33, 4, 2, 4, 5, 12, 12, 12, 12, 12, 14};
        //when
        Integer[] actual = arraz.copyArrayByIterator(oldArray);
        //then
        Assert.assertArrayEquals(expected, actual);
    }

    @Test
    public void test1copyArrayByLoop() {
        //given
        int [] oldArray = {12, 3, 4, 5};
        int [] expected = {12, 3, 4, 5};
        //when
        int [] actual = arraz.copyArrayByLoop(oldArray);
        //then
        Assert.assertArrayEquals(expected, actual);
    }

    @Test
    public void test2copyArrayByLoop() {
        //given
        int [] oldArray = {-3, -4, 12, 3};
        int [] expected = {-3, -4, 12, 3};
        //when
        int [] actual = arraz.copyArrayByLoop(oldArray);
        //then
        Assert.assertArrayEquals(expected, actual);
    }

    @Test
    public void test1RemoveElementFromArray() {
        //given
        int [] intArray = {1, 2, 3, 4};
        int valueToRemove = 2;
        int [] newArray = {1, 3, 4};
        //when
        int [] actual = arraz.removeElementFromArray(intArray, valueToRemove);
        //then
        Assert.assertArrayEquals(newArray, actual);
    }


    @Test
    public void test2RemoveElementFromArray() {
        //given
        int [] intArray = {1, 2, 3, 5, 6, 10};
        int valueToRemove = 3;
        int [] newArray = {1, 2, 5, 6, 10};
        //when
        int [] actual = arraz.removeElementFromArray(intArray, valueToRemove);
        //then
        Assert.assertArrayEquals(newArray, actual);
    }

    @Test
    public void test1InsertIntoArrayAt() {
        //given
        int [] intArray = {1, 2, 4};
        int newIndex = 2;
        int numberToInsert = 3;
        int [] expected = {1, 2, 3, 4};
        //when
        int [] actual = arraz.insertIntoArrayAt(intArray, newIndex, numberToInsert);
        //then
        Assert.assertArrayEquals(expected, actual);

    }

    @Test
    public void test2InsertIntoArrayAt() {
        //given
        int [] intArray = {2, 3, 4, 5};
        int newIndex = 0;
        int numberToInsert = 1;
        int [] expected = {1, 2, 3, 4, 5};
        //when
        int [] actual = arraz.insertIntoArrayAt(intArray, newIndex, numberToInsert);
        //then
        Assert.assertArrayEquals(expected, actual);
    }

    @Test
    public void test1FindMaxMinOfArray() {
        //given
        int [] intArray = {1, 2, 3, 4};
        int expected = 4;
        //when
        MinMax minMax = arraz.findMaxMinOfArray(intArray);
        int actual = minMax.getMax();
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2FindMaxMinOfArray() {
        //given
        int [] intArray = {1, 2, 3, 4};
        int expected = 1;
        //when
        MinMax minMax = arraz.findMaxMinOfArray(intArray);
        int actual = minMax.getMin();
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test3ScrambledFindMaxMinOfArray() {
        //given
        int [] intArray = {2, 3, 4, 5 , 4, 5, 6, 7};
        int expected = 7;
        //when
        MinMax minMax = arraz.findMaxMinOfArray(intArray);
        int actual = minMax.getMax();
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1CountDupesFromArray() {
        //given
        Integer [] ints = {1, 2, 3, 4, 4};
        Integer expected = 1;
        //when
        Integer actual = arraz.countDupes(ints);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2CountDupesFromArray() {
        //given
        Integer [] ints = {1, 2, 3, 2, 2};
        Integer expected = 1;
        //when
        Integer actual = arraz.countDupes(ints);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1RemoveDupesFromArray() {
        //given
        Integer [] ints = {1, 2, 3, 4, 4};
        Integer [] expected = {1, 2, 3};
        //when
        Integer [] actual = arraz.removeDupesFromArray(ints);
        //then
        Assert.assertArrayEquals(expected, actual);
    }


    @Test
    public void test1find2ndLargestValueFromArray() {
        //given
        Double [] doubles = {1.0, 2.0, 3.0, 4.0, 5.0};
        Double expected = 4.0;
        //when
        Double actual = arraz.find2ndLargestValueFromArray(doubles);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2find2ndLargestValueFromArray() {
        //given
        Double [] doubles = {4.0, 3.0, 2.0, 7.0, 10.0};
        Double expected = 7.0;
        //when
        Double actual = arraz.find2ndLargestValueFromArray(doubles);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1makeMeAnArrayListFromArray() {
        //given
        int [] ints = {1, 2, 3, 4, 5};
        //when
        //stuck
    }

    @Test
    public void test1check2ArraysForEqual() {
        //given
        int [] intArray1 = {1, 2, 3, 4};
        int [] intArray2 = {1, 2, 3, 4};
        //when
        boolean actual = arraz.check2ArraysForEqual(intArray1, intArray2);
        //then
        Assert.assertTrue(actual);
    }

    @Test
    public void test2check2ArraysForEqual() {
        //given
        int [] intArray1 = {1, 2, 3, 4};
        int [] intArray2 = {1, 3, 4};
        //when
        boolean actual = arraz.check2ArraysForEqual(intArray1, intArray2);
        //then
        Assert.assertFalse(actual);
    }

    @Test
    public void test1AverageArrayWithoutMaxMin() {
        //given
        int [] ints = {1, 2, 3, 4};
        int expected = 2;
        //when
        int actual = arraz.averageArrayWithoutMaxMin(ints);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2AverageArrayWithoutMaxMin() {
        //given
        int [] ints = {1, 4, 5, 7, 8 ,3, 5, 10};
        int expected = 5;
        //when
        int actual = arraz.averageArrayWithoutMaxMin(ints);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1arrayHas65and77() {
        //given
        int [] ints = {1, 2, 4, 5, 65, 34};
        boolean expected = false;
        //when
        boolean actual = arraz.arrayHas65and77(ints);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2arrayHas65and77() {
        //given
        int [] ints = {1, 2, 65, 77};
        //when
        boolean actual = arraz.arrayHas65and77(ints);
        //then
        Assert.assertTrue(actual);
    }

    @Test
    public void test3arrayHas65and77() {
        //given
        int [] ints = {1, 77, 40, 65};
        //when
        boolean actual = arraz.arrayHas65and77(ints);
        //then
        Assert.assertTrue(actual);
    }

    @Test
    public void test1theTotalofTensIs30() {
        //given
        Integer [] ints = {1, 2, 10, 10, 1};
        boolean expected = false;
        //when
        boolean actual = arraz.theTotalOfTensIs30(ints);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2theTotalofTensIs30() {
        //given
        Integer [] ints = {1, 10, 10, 10};
        boolean expected = true;
        //when
        boolean actual = arraz.theTotalOfTensIs30(ints);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1findSecondSmallestValueFromArray() {
        //given
        int [] ints = {1, 3, 5, 10};
        int expected = 3;
        //when
        int actual = arraz.findSecondSmallValueFromArray(ints);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1makeMeACopyPlease() {
        //given
        int [] ints = {1, 2, 3, 4};
        int [] expected = {4, 3, 2, 1};

        //when
        int [] actual = arraz.makeMeACopyPlease(ints);
        //then
        Assert.assertArrayEquals(expected, actual);
    }

    @Test
    public void test2makeMeACopyPlease() {
        //given
        int [] ints = {2, 4, 5, 7, 4};
        int [] expected = {4, 7, 5, 4, 2};
        //when
        int [] actual = arraz.makeMeACopyPlease(ints);
        //then
        Assert.assertArrayEquals(expected, actual);
    }
    
}
